Index: palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- palm/trunk/SOURCE/data_output_module.f90	(revision 4146)
+++ palm/trunk/SOURCE/data_output_module.f90	(revision 4147)
@@ -3109,135 +3138,135 @@
 !> Write attribute to file.
 !--------------------------------------------------------------------------------------------------!
-FUNCTION write_attribute( file_format, file_id, file_name,        &
-                          variable_id, variable_name, attribute ) RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  file_format    !< file format chosen for file
-   CHARACTER(LEN=*), INTENT(IN) ::  file_name      !< file name
-   CHARACTER(LEN=*), INTENT(IN) ::  variable_name  !< variable name
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'write_attribute'  !< file format chosen for file
-
-   INTEGER, INTENT(IN) ::  file_id              !< file ID
-   INTEGER             ::  return_value         !< return value
-   INTEGER             ::  output_return_value  !< return value of a called output routine
-   INTEGER, INTENT(IN) ::  variable_id          !< variable ID
-
-   TYPE(attribute_type), INTENT(IN) ::  attribute  !< attribute to be written
-
-
-   return_value = 0
-   output_return_value = 0
-
-   !-- Prepare for possible error message
-   temp_string = '(file "' // TRIM( file_name ) //           &
-                 '", variable "' // TRIM( variable_name ) // &
-                 '", attribute "' // TRIM( attribute%name ) // '")'
-
-   !-- Write attribute to file
-   SELECT CASE ( TRIM( file_format ) )
-
-      CASE ( 'binary' )
-
-         SELECT CASE ( TRIM( attribute%data_type ) )
-
-            CASE( 'char' )
-               CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,  &
-                       attribute_name=attribute%name, value_char=attribute%value_char, &
-                       return_value=output_return_value )
-
-            CASE( 'int8' )
-               CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,  &
-                       attribute_name=attribute%name, value_int8=attribute%value_int8, &
-                       return_value=output_return_value )
-
-            CASE( 'int16' )
-               CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,    &
-                       attribute_name=attribute%name, value_int16=attribute%value_int16, &
-                       return_value=output_return_value )
-
-            CASE( 'int32' )
-               CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,    &
-                       attribute_name=attribute%name, value_int32=attribute%value_int32, &
-                       return_value=output_return_value )
-
-            CASE( 'real32' )
-               CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,      &
-                       attribute_name=attribute%name, value_real32=attribute%value_real32, &
-                       return_value=output_return_value )
-
-            CASE( 'real64' )
-               CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,      &
-                       attribute_name=attribute%name, value_real64=attribute%value_real64, &
-                       return_value=output_return_value )
-
-            CASE DEFAULT
-               return_value = 1
-               CALL internal_message( 'error', routine_name //                     &
-                                      ': file format "' // TRIM( file_format ) //  &
-                                      '" does not support attribute data type "'// &
-                                      TRIM( attribute%data_type ) //               &
-                                      '" ' // TRIM( temp_string ) )
-
-         END SELECT
-
-      CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
-
-         SELECT CASE ( TRIM( attribute%data_type ) )
-
-            CASE( 'char' )
-               CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id, &
-                       attribute_name=attribute%name, value_char=attribute%value_char, &
-                       return_value=output_return_value )
-
-            CASE( 'int8' )
-               CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id, &
-                       attribute_name=attribute%name, value_int8=attribute%value_int8, &
-                       return_value=output_return_value )
-
-            CASE( 'int16' )
-               CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,   &
-                       attribute_name=attribute%name, value_int16=attribute%value_int16, &
-                       return_value=output_return_value )
-
-            CASE( 'int32' )
-               CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,   &
-                       attribute_name=attribute%name, value_int32=attribute%value_int32, &
-                       return_value=output_return_value )
-
-            CASE( 'real32' )
-               CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,     &
-                       attribute_name=attribute%name, value_real32=attribute%value_real32, &
-                       return_value=output_return_value )
-
-            CASE( 'real64' )
-               CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,     &
-                       attribute_name=attribute%name, value_real64=attribute%value_real64, &
-                       return_value=output_return_value )
-
-            CASE DEFAULT
-               return_value = 1
-               CALL internal_message( 'error', routine_name //                     &
-                                      ': file format "' // TRIM( file_format ) //  &
-                                      '" does not support attribute data type "'// &
-                                      TRIM( attribute%data_type ) //               &
-                                      '" ' // TRIM( temp_string ) )
-
-         END SELECT
-
-      CASE DEFAULT
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                                &
-                                ': unsupported file format "' // TRIM( file_format ) // &
-                                '" ' // TRIM( temp_string ) )
-
-   END SELECT
-
-   IF ( output_return_value /= 0 )  THEN
-      return_value = output_return_value
-      CALL internal_message( 'error', routine_name // &
-                             ': error while writing attribute ' // TRIM( temp_string ) )
-   ENDIF
-
-END FUNCTION write_attribute
+ FUNCTION write_attribute( file_format, file_id, file_name,        &
+                           variable_id, variable_name, attribute ) RESULT( return_value )
+
+    CHARACTER(LEN=*), INTENT(IN) ::  file_format    !< file format chosen for file
+    CHARACTER(LEN=*), INTENT(IN) ::  file_name      !< file name
+    CHARACTER(LEN=*), INTENT(IN) ::  variable_name  !< variable name
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'write_attribute'  !< file format chosen for file
+
+    INTEGER, INTENT(IN) ::  file_id              !< file ID
+    INTEGER             ::  return_value         !< return value
+    INTEGER             ::  output_return_value  !< return value of a called output routine
+    INTEGER, INTENT(IN) ::  variable_id          !< variable ID
+
+    TYPE(attribute_type), INTENT(IN) ::  attribute  !< attribute to be written
+
+
+    return_value = 0
+    output_return_value = 0
+!
+!-- Prepare for possible error message
+    temp_string = '(file "' // TRIM( file_name ) //           &
+                  '", variable "' // TRIM( variable_name ) // &
+                  '", attribute "' // TRIM( attribute%name ) // '")'
+!
+!-- Write attribute to file
+    SELECT CASE ( TRIM( file_format ) )
+
+       CASE ( 'binary' )
+
+          SELECT CASE ( TRIM( attribute%data_type ) )
+
+             CASE( 'char' )
+                CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,  &
+                        attribute_name=attribute%name, value_char=attribute%value_char, &
+                        return_value=output_return_value )
+
+             CASE( 'int8' )
+                CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,  &
+                        attribute_name=attribute%name, value_int8=attribute%value_int8, &
+                        return_value=output_return_value )
+
+             CASE( 'int16' )
+                CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,    &
+                        attribute_name=attribute%name, value_int16=attribute%value_int16, &
+                        return_value=output_return_value )
+
+             CASE( 'int32' )
+                CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,    &
+                        attribute_name=attribute%name, value_int32=attribute%value_int32, &
+                        return_value=output_return_value )
+
+             CASE( 'real32' )
+                CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,      &
+                        attribute_name=attribute%name, value_real32=attribute%value_real32, &
+                        return_value=output_return_value )
+
+             CASE( 'real64' )
+                CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,      &
+                        attribute_name=attribute%name, value_real64=attribute%value_real64, &
+                        return_value=output_return_value )
+
+             CASE DEFAULT
+                return_value = 1
+                CALL internal_message( 'error', routine_name //                     &
+                                       ': file format "' // TRIM( file_format ) //  &
+                                       '" does not support attribute data type "'// &
+                                       TRIM( attribute%data_type ) //               &
+                                       '" ' // TRIM( temp_string ) )
+
+          END SELECT
+
+       CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
+
+          SELECT CASE ( TRIM( attribute%data_type ) )
+
+             CASE( 'char' )
+                CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id, &
+                        attribute_name=attribute%name, value_char=attribute%value_char, &
+                        return_value=output_return_value )
+
+             CASE( 'int8' )
+                CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id, &
+                        attribute_name=attribute%name, value_int8=attribute%value_int8, &
+                        return_value=output_return_value )
+
+             CASE( 'int16' )
+                CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,   &
+                        attribute_name=attribute%name, value_int16=attribute%value_int16, &
+                        return_value=output_return_value )
+
+             CASE( 'int32' )
+                CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,   &
+                        attribute_name=attribute%name, value_int32=attribute%value_int32, &
+                        return_value=output_return_value )
+
+             CASE( 'real32' )
+                CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,     &
+                        attribute_name=attribute%name, value_real32=attribute%value_real32, &
+                        return_value=output_return_value )
+
+             CASE( 'real64' )
+                CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,     &
+                        attribute_name=attribute%name, value_real64=attribute%value_real64, &
+                        return_value=output_return_value )
+
+             CASE DEFAULT
+                return_value = 1
+                CALL internal_message( 'error', routine_name //                     &
+                                       ': file format "' // TRIM( file_format ) //  &
+                                       '" does not support attribute data type "'// &
+                                       TRIM( attribute%data_type ) //               &
+                                       '" ' // TRIM( temp_string ) )
+
+          END SELECT
+
+       CASE DEFAULT
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                                &
+                                 ': unsupported file format "' // TRIM( file_format ) // &
+                                 '" ' // TRIM( temp_string ) )
+
+    END SELECT
+
+    IF ( output_return_value /= 0 )  THEN
+       return_value = output_return_value
+       CALL internal_message( 'error', routine_name // &
+                              ': error while writing attribute ' // TRIM( temp_string ) )
+    ENDIF
+
+ END FUNCTION write_attribute
 
 !--------------------------------------------------------------------------------------------------!
@@ -3246,51 +3275,51 @@
 !> Get dimension IDs and save them to variables.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE collect_dimesion_ids_for_variables( file_name, variables, dimensions, return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  file_name !< name of file
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'collect_dimesion_ids_for_variables'  !< file format chosen for file
-
-   INTEGER              ::  d             !< loop index
-   INTEGER              ::  i             !< loop index
-   INTEGER              ::  j             !< loop index
-   INTEGER              ::  ndims         !< number of dimensions
-   INTEGER              ::  nvars         !< number of variables
-   INTEGER, INTENT(OUT) ::  return_value  !< return value
-
-   LOGICAL ::  found  !< true if dimension required by variable was found in dimension list
-
-   TYPE(dimension_type), DIMENSION(:), INTENT(IN) ::  dimensions  !< list of dimensions in file
-
-   TYPE(variable_type), DIMENSION(:), INTENT(INOUT) ::  variables  !< list of variables in file
-
-
-   return_value  = 0
-   ndims = SIZE( dimensions )
-   nvars = SIZE( variables )
-
-   DO  i = 1, nvars
-      DO  j = 1, SIZE( variables(i)%dimension_names )
-         found = .FALSE.
-         DO  d = 1, ndims
-            IF ( variables(i)%dimension_names(j) == dimensions(d)%name )  THEN
-               variables(i)%dimension_ids(j) = dimensions(d)%id
-               found = .TRUE.
-               EXIT
-            ENDIF
-         ENDDO
-         IF ( .NOT. found )  THEN
-            return_value = 1
-            CALL internal_message( 'error', routine_name //                                &
-                    ': required dimension "' // TRIM( variables(i)%dimension_names(j) ) // &
-                    '" is undefined (variable "' // TRIM( variables(i)%name ) //           &
-                    '", file "' // TRIM( file_name ) // '")!' )
-            EXIT
-         ENDIF
-      ENDDO
-      IF ( .NOT. found )  EXIT
-   ENDDO
-
-END SUBROUTINE collect_dimesion_ids_for_variables
+ SUBROUTINE collect_dimesion_ids_for_variables( file_name, variables, dimensions, return_value )
+
+    CHARACTER(LEN=*), INTENT(IN) ::  file_name !< name of file
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'collect_dimesion_ids_for_variables'  !< file format chosen for file
+
+    INTEGER              ::  d             !< loop index
+    INTEGER              ::  i             !< loop index
+    INTEGER              ::  j             !< loop index
+    INTEGER              ::  ndims         !< number of dimensions
+    INTEGER              ::  nvars         !< number of variables
+    INTEGER, INTENT(OUT) ::  return_value  !< return value
+
+    LOGICAL ::  found  !< true if dimension required by variable was found in dimension list
+
+    TYPE(dimension_type), DIMENSION(:), INTENT(IN) ::  dimensions  !< list of dimensions in file
+
+    TYPE(variable_type), DIMENSION(:), INTENT(INOUT) ::  variables  !< list of variables in file
+
+
+    return_value  = 0
+    ndims = SIZE( dimensions )
+    nvars = SIZE( variables )
+
+    DO  i = 1, nvars
+       DO  j = 1, SIZE( variables(i)%dimension_names )
+          found = .FALSE.
+          DO  d = 1, ndims
+             IF ( variables(i)%dimension_names(j) == dimensions(d)%name )  THEN
+                variables(i)%dimension_ids(j) = dimensions(d)%id
+                found = .TRUE.
+                EXIT
+             ENDIF
+          ENDDO
+          IF ( .NOT. found )  THEN
+             return_value = 1
+             CALL internal_message( 'error', routine_name //                                &
+                     ': required dimension "' // TRIM( variables(i)%dimension_names(j) ) // &
+                     '" is undefined (variable "' // TRIM( variables(i)%name ) //           &
+                     '", file "' // TRIM( file_name ) // '")!' )
+             EXIT
+          ENDIF
+       ENDDO
+       IF ( .NOT. found )  EXIT
+    ENDDO
+
+ END SUBROUTINE collect_dimesion_ids_for_variables
 
 !--------------------------------------------------------------------------------------------------!
@@ -3301,47 +3330,47 @@
 !> @todo Do we need an MPI barrier at the end?
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE stop_file_header_definition( file_format, file_id, file_name, return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< file format
-   CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< file name
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'stop_file_header_definition'  !< name of routine
-
-   INTEGER, INTENT(IN)  ::  file_id              !< file id
-   INTEGER              ::  output_return_value  !< return value of a called output routine
-   INTEGER, INTENT(OUT) ::  return_value         !< return value
-
-
-   return_value = 0
-   output_return_value = 0
-
-   temp_string = '(file "' // TRIM( file_name ) // '")'
-
-   SELECT CASE ( TRIM( file_format ) )
-
-      CASE ( 'binary' )
-         CALL binary_stop_file_header_definition( file_id, output_return_value )
-
-      CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
-         CALL netcdf4_stop_file_header_definition( file_id, output_return_value )
-
-      CASE DEFAULT
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                    &
-                                ': file format "' // TRIM( file_format ) // &
-                                '" not supported ' // TRIM( temp_string ) )
-
-   END SELECT
-
-   IF ( output_return_value /= 0 )  THEN
-      return_value = output_return_value
-      CALL internal_message( 'error', routine_name //                          &
-                             ': error while leaving file-definition state ' // &
-                             TRIM( temp_string ) )
-   ENDIF
-
-   ! CALL MPI_Barrier( MPI_COMM_WORLD, return_value )
-
-END SUBROUTINE stop_file_header_definition
+ SUBROUTINE stop_file_header_definition( file_format, file_id, file_name, return_value )
+
+    CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< file format
+    CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< file name
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'stop_file_header_definition'  !< name of routine
+
+    INTEGER, INTENT(IN)  ::  file_id              !< file id
+    INTEGER              ::  output_return_value  !< return value of a called output routine
+    INTEGER, INTENT(OUT) ::  return_value         !< return value
+
+
+    return_value = 0
+    output_return_value = 0
+
+    temp_string = '(file "' // TRIM( file_name ) // '")'
+
+    SELECT CASE ( TRIM( file_format ) )
+
+       CASE ( 'binary' )
+          CALL binary_stop_file_header_definition( file_id, output_return_value )
+
+       CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
+          CALL netcdf4_stop_file_header_definition( file_id, output_return_value )
+
+       CASE DEFAULT
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                    &
+                                 ': file format "' // TRIM( file_format ) // &
+                                 '" not supported ' // TRIM( temp_string ) )
+
+    END SELECT
+
+    IF ( output_return_value /= 0 )  THEN
+       return_value = output_return_value
+       CALL internal_message( 'error', routine_name //                          &
+                              ': error while leaving file-definition state ' // &
+                              TRIM( temp_string ) )
+    ENDIF
+
+    ! CALL MPI_Barrier( MPI_COMM_WORLD, return_value )
+
+ END SUBROUTINE stop_file_header_definition
 
 !--------------------------------------------------------------------------------------------------!
@@ -3350,121 +3379,121 @@
 !> Find a requested variable 'variable_name' and its used dimensions in requested file 'file_name'.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE find_var_in_file( file_name, variable_name, file_format, file_id, variable_id, &
-                             is_global, dimensions, return_value )
-
-   CHARACTER(LEN=charlen), INTENT(OUT) ::  file_format    !< file format chosen for file
-   CHARACTER(LEN=*),       INTENT(IN)  ::  file_name      !< name of file
-   CHARACTER(LEN=*),       INTENT(IN)  ::  variable_name  !< name of variable
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'find_var_in_file'  !< name of routine
-
-   INTEGER              ::  d             !< loop index
-   INTEGER              ::  dd            !< loop index
-   INTEGER              ::  f             !< loop index
-   INTEGER, INTENT(OUT) ::  file_id       !< file ID
-   INTEGER, INTENT(OUT) ::  return_value  !< return value
-   INTEGER, INTENT(OUT) ::  variable_id   !< variable ID
-
-   INTEGER, DIMENSION(:), ALLOCATABLE ::  dimension_ids  !< list of dimension IDs used by variable
-
-   LOGICAL              ::  found      !< true if requested variable found in requested file
-   LOGICAL, INTENT(OUT) ::  is_global  !< true if variable is global
-
-   TYPE(dimension_type), DIMENSION(:), ALLOCATABLE, INTENT(OUT) ::  dimensions  !< list of dimensions used by variable
-
-
-   return_value = 0
-   found = .FALSE.
-
-   DO  f = 1, nfiles
-      IF ( TRIM( file_name ) == TRIM( files(f)%name ) )  THEN
-
-         IF ( .NOT. files(f)%is_init )  THEN
-            return_value = 1
-            CALL internal_message( 'error', routine_name //                     &
-                                   ': file not initialized. ' //                &
-                                   'Writing variable to file is impossible ' // &
-                                   '(variable "' // TRIM( variable_name ) //    &
-                                   '", file "' // TRIM( file_name ) // '")!' )
-            EXIT
-         ENDIF
-
-         file_id     = files(f)%id
-         file_format = files(f)%format
-
-         !-- Search for variable in file
-         DO  d = 1, SIZE( files(f)%variables )
-            IF ( TRIM( variable_name ) == TRIM( files(f)%variables(d)%name ) )  THEN
-
-               variable_id    = files(f)%variables(d)%id
-               is_global = files(f)%variables(d)%is_global
-
-               ALLOCATE( dimension_ids(SIZE( files(f)%variables(d)%dimension_ids )) )
-               ALLOCATE( dimensions(SIZE( files(f)%variables(d)%dimension_ids )) )
-
-               dimension_ids = files(f)%variables(d)%dimension_ids
-
-               found = .TRUE.
-               EXIT
-
-            ENDIF
-         ENDDO
-
-         IF ( found )  THEN
-
-            !-- Get list of dimensions used by variable
-            DO  d = 1, SIZE( files(f)%dimensions )
-               DO  dd = 1, SIZE( dimension_ids )
-                  IF ( dimension_ids(dd) == files(f)%dimensions(d)%id )  THEN
-                     dimensions(dd) = files(f)%dimensions(d)
-                     EXIT
-                  ENDIF
-               ENDDO
-            ENDDO
-
-         ELSE
-
-            !-- If variable was not found, search for a dimension instead
-            DO  d = 1, SIZE( files(f)%dimensions )
-               IF ( TRIM( variable_name ) == TRIM( files(f)%dimensions(d)%name ) )  THEN
-
-                  variable_id    = files(f)%dimensions(d)%variable_id
-                  is_global = .TRUE.
-
-                  ALLOCATE( dimensions(1) )
-
-                  dimensions(1) = files(f)%dimensions(d)
-
-                  found = .TRUE.
-                  EXIT
-
-               ENDIF
-            ENDDO
-
-         ENDIF
-
-         !-- If variable was not found in requested file, return an error
-         IF ( .NOT. found )  THEN
-            return_value = 1
-            CALL internal_message( 'error', routine_name //                  &
-                                   ': variable not found in file ' //        &
-                                   '(variable "' // TRIM( variable_name ) // &
-                                   '", file "' // TRIM( file_name ) // '")!' )
-         ENDIF
-
-         EXIT
-
-      ENDIF  ! file found
-   ENDDO  ! loop over files
-
-   IF ( .NOT. found  .AND.  return_value == 0 )  THEN
-      return_value = 1
-      CALL internal_message( 'error', routine_name //                  &
-                             ': file not found ' //                    &
-                             '(variable "' // TRIM( variable_name ) // &
-                             '", file "' // TRIM( file_name ) // '")!' )
-   ENDIF
-
-END SUBROUTINE find_var_in_file
+ SUBROUTINE find_var_in_file( file_name, variable_name, file_format, file_id, variable_id, &
+                              is_global, dimensions, return_value )
+
+    CHARACTER(LEN=charlen), INTENT(OUT) ::  file_format    !< file format chosen for file
+    CHARACTER(LEN=*),       INTENT(IN)  ::  file_name      !< name of file
+    CHARACTER(LEN=*),       INTENT(IN)  ::  variable_name  !< name of variable
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'find_var_in_file'  !< name of routine
+
+    INTEGER              ::  d             !< loop index
+    INTEGER              ::  dd            !< loop index
+    INTEGER              ::  f             !< loop index
+    INTEGER, INTENT(OUT) ::  file_id       !< file ID
+    INTEGER, INTENT(OUT) ::  return_value  !< return value
+    INTEGER, INTENT(OUT) ::  variable_id   !< variable ID
+
+    INTEGER, DIMENSION(:), ALLOCATABLE ::  dimension_ids  !< list of dimension IDs used by variable
+
+    LOGICAL              ::  found      !< true if requested variable found in requested file
+    LOGICAL, INTENT(OUT) ::  is_global  !< true if variable is global
+
+    TYPE(dimension_type), DIMENSION(:), ALLOCATABLE, INTENT(OUT) ::  dimensions  !< list of dimensions used by variable
+
+
+    return_value = 0
+    found = .FALSE.
+
+    DO  f = 1, nfiles
+       IF ( TRIM( file_name ) == TRIM( files(f)%name ) )  THEN
+
+          IF ( .NOT. files(f)%is_init )  THEN
+             return_value = 1
+             CALL internal_message( 'error', routine_name //                     &
+                                    ': file not initialized. ' //                &
+                                    'Writing variable to file is impossible ' // &
+                                    '(variable "' // TRIM( variable_name ) //    &
+                                    '", file "' // TRIM( file_name ) // '")!' )
+             EXIT
+          ENDIF
+
+          file_id     = files(f)%id
+          file_format = files(f)%format
+!
+!--       Search for variable in file
+          DO  d = 1, SIZE( files(f)%variables )
+             IF ( TRIM( variable_name ) == TRIM( files(f)%variables(d)%name ) )  THEN
+
+                variable_id    = files(f)%variables(d)%id
+                is_global = files(f)%variables(d)%is_global
+
+                ALLOCATE( dimension_ids(SIZE( files(f)%variables(d)%dimension_ids )) )
+                ALLOCATE( dimensions(SIZE( files(f)%variables(d)%dimension_ids )) )
+
+                dimension_ids = files(f)%variables(d)%dimension_ids
+
+                found = .TRUE.
+                EXIT
+
+             ENDIF
+          ENDDO
+
+          IF ( found )  THEN
+!
+!--          Get list of dimensions used by variable
+             DO  d = 1, SIZE( files(f)%dimensions )
+                DO  dd = 1, SIZE( dimension_ids )
+                   IF ( dimension_ids(dd) == files(f)%dimensions(d)%id )  THEN
+                      dimensions(dd) = files(f)%dimensions(d)
+                      EXIT
+                   ENDIF
+                ENDDO
+             ENDDO
+
+          ELSE
+!
+!--          If variable was not found, search for a dimension instead
+             DO  d = 1, SIZE( files(f)%dimensions )
+                IF ( TRIM( variable_name ) == TRIM( files(f)%dimensions(d)%name ) )  THEN
+
+                   variable_id    = files(f)%dimensions(d)%variable_id
+                   is_global = .TRUE.
+
+                   ALLOCATE( dimensions(1) )
+
+                   dimensions(1) = files(f)%dimensions(d)
+
+                   found = .TRUE.
+                   EXIT
+
+                ENDIF
+             ENDDO
+
+          ENDIF
+!
+!--       If variable was not found in requested file, return an error
+          IF ( .NOT. found )  THEN
+             return_value = 1
+             CALL internal_message( 'error', routine_name //                  &
+                                    ': variable not found in file ' //        &
+                                    '(variable "' // TRIM( variable_name ) // &
+                                    '", file "' // TRIM( file_name ) // '")!' )
+          ENDIF
+
+          EXIT
+
+       ENDIF  ! file found
+    ENDDO  ! loop over files
+
+    IF ( .NOT. found  .AND.  return_value == 0 )  THEN
+       return_value = 1
+       CALL internal_message( 'error', routine_name //                  &
+                              ': file not found ' //                    &
+                              '(variable "' // TRIM( variable_name ) // &
+                              '", file "' // TRIM( file_name ) // '")!' )
+    ENDIF
+
+ END SUBROUTINE find_var_in_file
 
 !--------------------------------------------------------------------------------------------------!
